Merge: More escaping
[nit.git] / tests / tests.sh
1 #!/bin/bash
2 # This file is part of NIT ( http://www.nitlanguage.org ).
3 #
4 # Copyright 2004-2008 Jean Privat <jean@pryen.org>
5 #
6 # Licensed under the Apache License, Version 2.0 (the "License");
7 # you may not use this file except in compliance with the License.
8 # You may obtain a copy of the License at
9 #
10 # http://www.apache.org/licenses/LICENSE-2.0
11 #
12 # Unless required by applicable law or agreed to in writing, software
13 # distributed under the License is distributed on an "AS IS" BASIS,
14 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15 # See the License for the specific language governing permissions and
16 # limitations under the License.
17
18 # This shell script compile, run and verify Nit program files
19
20 # Set lang do default to avoid failed tests because of locale
21 export LANG=C
22 export LC_ALL=C
23 export NIT_TESTING=true
24 export MNIT_SRAND=0
25
26 unset NIT_DIR
27
28 # Get the first Java lib available
29 shopt -s nullglob
30 JAVA_HOME=$(dirname $(dirname $(readlink -f $(which javac))))
31
32 paths=`echo $JAVA_HOME/jre/lib/*/{client,server}/`
33 paths=($paths)
34 JNI_LIB_PATH=${paths[0]}
35 echo $JAVA_HOME
36 echo $JNI_LIB_PATH
37 shopt -u nullglob
38
39 outdir="out"
40 compdir=".nit_compile"
41
42 usage()
43 {
44 e=`basename "$0"`
45 cat<<END
46 Usage: $e [options] modulenames
47 -o option Pass option to the engine
48 -v Verbose (show tests steps)
49 -h This help
50 --engine Use a specific engine (default=nitg)
51 --noskip Do not skip a test even if the .skip file matches
52 --outdir Use a specific output folder (default=out/)
53 --compdir Use a specific temporary compilation folder (default=.nit_compile)
54 --node Run as a node in parallel, will not output context information
55 END
56 }
57
58 # Run a command with a timeout and a time count.
59 # Options:
60 # -o file write the user time into file (REQUIRED). see `-o` in `man time`
61 # -a append the time to the file (instead of overwriting it). see `-a` in `man time`
62 saferun()
63 {
64 local stop=false
65 local o=
66 local a=
67 while [ $stop = false ]; do
68 case "$1" in
69 -o) o="$2"; shift; shift;;
70 -a) a="-a"; shift;;
71 *) stop=true
72 esac
73 done
74 if test -n "$TIME"; then
75 $TIME -o "$o" $a $TIMEOUT "$@"
76 else
77 if test -n "$a"; then echo 0 >> "$o"; else echo 0 > "$o"; fi
78 $TIMEOUT "$@"
79 fi
80 }
81
82 # Output a timestamp attribute for XML, or an empty line
83 timestamp()
84 {
85 if test -n "$TIMESTAMP"; then
86 echo "timestamp='`$TIMESTAMP`'"
87 else
88 echo ""
89 fi
90
91 }
92
93 # Get platform specific commands ##########################
94
95 # Detect a working timeout
96 if sh -c "timelimit echo" 1>/dev/null 2>&1; then
97 TIMEOUT="timelimit -t 600"
98 elif sh -c "timeout 1 echo" 1>/dev/null 2>&1; then
99 TIMEOUT="timeout 600s"
100 else
101 echo "No timelimit or timeout command detected. Tests may hang :("
102 fi
103
104 # Detect a working time command
105 if env time --quiet -f%U true 2>/dev/null; then
106 TIME="env time --quiet -f%U"
107 elif env time -f%U true 2>/dev/null; then
108 TIME="env time -f%U"
109 else
110 TIME=
111 fi
112
113 # Detect a working date command
114 if date -Iseconds >/dev/null 2>&1; then
115 TIMESTAMP="date -Iseconds"
116 else
117 TIMESTAMP=
118 fi
119
120 # $1 is the pattern of the test
121 # $2 is the file to compare to
122 # the result is:
123 # 0: if the file to compare to do not exists
124 # 1: if the file match
125 # 2: if the file match with soso
126 # 3: if the file do not match
127 function compare_to_result()
128 {
129 local pattern="$1"
130 local sav="$2"
131 if [ ! -r "$sav" ]; then return 0; fi
132 test "`cat -- "$sav"`" = "UNDEFINED" && return 1
133 diff -u -- "$sav" "$outdir/$pattern.res" > "$outdir/$pattern.diff.sav.log"
134 if [ "$?" == 0 ]; then
135 return 1
136 fi
137 sed '/[Ww]arning/d;/[Ee]rror/d' "$outdir/$pattern.res" > "$outdir/$pattern.res2"
138 sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "$outdir/$pattern.sav2"
139 grep '[Ee]rror' "$outdir/$pattern.res" >/dev/null && echo "Error" >> "$outdir/$pattern.res2"
140 grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "$outdir/$pattern.sav2"
141 diff -u "$outdir/$pattern.sav2" "$outdir/$pattern.res2" > "$outdir/$pattern.diff.sav.log2"
142 if [ "$?" == 0 ]; then
143 return 2
144 else
145 return 3
146 fi
147 }
148
149 function xmlesc()
150 {
151 sed 's/&/\&amp;/g; s/</\&lt;/g; s/>/\&gt;/g; s/"/\&quot;/g; s/'"'"'/\&#39;/g'<<EOF
152 $*
153 EOF
154 }
155
156 # As argument: the pattern used for the file
157 function process_result()
158 {
159 # Result
160 pattern=$1
161 description=$2
162 pack=$3
163 SAV=""
164 NSAV=""
165 FIXME=""
166 NFIXME=""
167 SOSO=""
168 NSOSO=""
169 SOSOF=""
170 NSOSOF=""
171 OLD=""
172 LIST=""
173 FIRST=""
174 echo >>$xml "<testcase classname='`xmlesc "$pack"`' name='`xmlesc "$description"`' time='`cat -- "$outdir/$pattern.time.out"`' `timestamp`>"
175 #for sav in "sav/$engine/fixme/$pattern.res" "sav/$engine/$pattern.res" "sav/fixme/$pattern.res" "sav/$pattern.res" "sav/$pattern.sav"; do
176 for savdir in $savdirs; do
177 sav=$savdir/fixme/$pattern.res
178 compare_to_result "$pattern" "$sav"
179 case "$?" in
180 0)
181 ;; # no file
182 1)
183 OLD="$LIST"
184 FIXME="$sav"
185 LIST="$LIST $sav"
186 ;;
187 2)
188 if [ -z "$FIRST" ]; then
189 SOSOF="$sav"
190 FIRST="$sav"
191 fi
192 LIST="$LIST $sav"
193 ;;
194 3)
195 if [ -z "$FIRST" ]; then
196 NFIXME="$sav"
197 FIRST="$sav"
198 fi
199 LIST="$LIST $sav"
200 ;;
201 esac
202
203 sav=$savdir/$pattern.res
204 compare_to_result "$pattern" "$sav"
205 case "$?" in
206 0)
207 ;; # no file
208 1)
209 OLD="$LIST"
210 SAV="$sav"
211 LIST="$LIST $sav"
212 ;;
213 2)
214 if [ -z "$FIRST" ]; then
215 SOSO="$sav"
216 FIRST="$sav"
217 fi
218 LIST="$LIST $sav"
219 ;;
220 3)
221 if [ -z "$FIRST" ]; then
222 NSAV="$sav"
223 FIRST="$sav"
224 fi
225 LIST="$LIST $sav"
226 ;;
227 esac
228 done
229 OLD=`echo "$OLD" | sed -e 's/ */ /g' -e 's/^ //' -e 's/ $//'`
230 grep 'NOT YET IMPLEMENTED' "$outdir/$pattern.res" >/dev/null
231 NYI="$?"
232 if [ -n "$SAV" ]; then
233 if [ -n "$OLD" ]; then
234 echo "[*ok*] $outdir/$pattern.res $SAV - but $OLD remains!"
235 echo >>$xml "<error message='`xmlesc "ok $outdir/$pattern.res - but $OLD remains"`'/>"
236 remains="$remains $OLD"
237 else
238 echo "[ok] $outdir/$pattern.res $SAV"
239 fi
240 ok="$ok $pattern"
241 elif [ -n "$FIXME" ]; then
242 if [ -n "$OLD" ]; then
243 echo "[*fixme*] $outdir/$pattern.res $FIXME - but $OLD remains!"
244 echo >>$xml "<error message='`xmlesc "ok $outdir/$pattern.res - but $OLD remains"`'/>"
245 remains="$remains $OLD"
246 else
247 echo "[fixme] $outdir/$pattern.res $FIXME"
248 echo >>$xml "<skipped/>"
249 fi
250 todos="$todos $pattern"
251 elif [ "x$NYI" = "x0" ]; then
252 echo "[todo] $outdir/$pattern.res -> not yet implemented"
253 echo >>$xml "<skipped/>"
254 todos="$todos $pattern"
255 elif [ -n "$SOSO" ]; then
256 echo "[======= soso $outdir/$pattern.res $SOSO =======]"
257 echo >>$xml "<error message='`xmlesc "soso $outdir/$pattern.res $SOSO"`'/>"
258 echo >>$xml "<system-out><![CDATA["
259 cat -v -- "$outdir/$pattern.diff.sav.log" | head >>$xml -n 50
260 echo >>$xml "]]></system-out>"
261 nok="$nok $pattern"
262 echo "$ii" >> "$ERRLIST"
263 elif [ -n "$SOSOF" ]; then
264 echo "[======= fixme soso $outdir/$pattern.res $SOSOF =======]"
265 echo >>$xml "<error message='`xmlesc "soso $outdir/$pattern.res $SOSO"`'/>"
266 echo >>$xml "<system-out><![CDATA["
267 cat -v -- "$outdir/$pattern.diff.sav.log" | head >>$xml -n 50
268 echo >>$xml "]]></system-out>"
269 nok="$nok $pattern"
270 echo "$ii" >> "$ERRLIST"
271 elif [ -n "$NSAV" ]; then
272 echo "[======= fail $outdir/$pattern.res $NSAV =======]"
273 echo >>$xml "<error message='`xmlesc "fail $outdir/$pattern.res $NSAV"`'/>"
274 echo >>$xml "<system-out><![CDATA["
275 cat -v -- "$outdir/$pattern.diff.sav.log" | head >>$xml -n 50
276 echo >>$xml "]]></system-out>"
277 nok="$nok $pattern"
278 echo "$ii" >> "$ERRLIST"
279 elif [ -n "$NFIXME" ]; then
280 echo "[======= changed $outdir/$pattern.res $NFIXME ======]"
281 echo >>$xml "<error message='`xmlesc "changed $outdir/$pattern.res $NFIXME"`'/>"
282 echo >>$xml "<system-out><![CDATA["
283 cat -v -- "$outdir/$pattern.diff.sav.log" | head >>$xml -n 50
284 echo >>$xml "]]></system-out>"
285 nok="$nok $pattern"
286 echo "$ii" >> "$ERRLIST"
287 elif [ -s "$outdir/$pattern.res" ]; then
288 echo "[=== no sav ===] $outdir/$pattern.res is not empty"
289 echo >>$xml "<error message='no sav and not empty'/>"
290 echo >>$xml "<system-out><![CDATA["
291 cat -v >>$xml -- "$outdir/$pattern.res"
292 echo >>$xml "]]></system-out>"
293 nos="$nos $pattern"
294 echo "$ii" >> "$ERRLIST"
295 else
296 # no sav but empty res
297 echo "[0k] $outdir/$pattern.res is empty"
298 ok="$ok $pattern"
299 fi
300 if test -s "$outdir/$pattern.cmp.err"; then
301 echo >>$xml "<system-err><![CDATA["
302 cat -v >>$xml -- "$outdir/$pattern.cmp.err"
303 echo >>$xml "]]></system-err>"
304 fi
305 echo >>$xml "</testcase>"
306 }
307
308 need_skip()
309 {
310 test "$noskip" = true && return 1
311 if echo "$1" | grep -f "$engine.skip" >/dev/null 2>&1; then
312 echo "=> $2: [skip]"
313 echo >>$xml "<testcase classname='`xmlesc "$3"`' name='`xmlesc "$2"`' `timestamp`><skipped/></testcase>"
314 return 0
315 fi
316 if test -n "$isinterpret" && echo "$1" | grep -f "exec.skip" >/dev/null 2>&1; then
317 echo "=> $2: [skip exec]"
318 echo >>$xml "<testcase classname='`xmlesc "$3"`' name='`xmlesc "$2"`' `timestamp`><skipped/></testcase>"
319 return 0
320 fi
321 return 1
322 }
323
324 skip_exec()
325 {
326 test "$noskip" = true && return 1
327 if echo "$1" | grep -f "exec.skip" >/dev/null 2>&1; then
328 echo -n "_ "
329 return 0
330 fi
331 return 1
332 }
333
334 skip_cc()
335 {
336 test "$noskip" = true && return 1
337 if echo "$1" | grep -f "cc.skip" >/dev/null 2>&1; then
338 return 0
339 fi
340 return 1
341 }
342
343 find_nitc()
344 {
345 name="$enginebinname"
346 recent=`ls -t ../src/$name ../src/$name_[0-9] ../bin/$name ../c_src/$name 2>/dev/null | head -1`
347 if [[ "x$recent" == "x" ]]; then
348 echo "Could not find binary for engine $engine, aborting"
349 exit 1
350 fi
351 if [ "x$isnode" = "xfalse" ]; then
352 echo "Found binary for engine $engine: $recent $OPT"
353 fi
354 NITC=$recent
355 }
356
357 verbose=false
358 isnode=false
359 stop=false
360 engine=nitg
361 noskip=
362 savdirs=
363 while [ $stop = false ]; do
364 case $1 in
365 -o) OPT="$OPT $2"; shift; shift;;
366 -v) verbose=true; shift;;
367 -h) usage; exit;;
368 --engine) engine="$2"; shift; shift;;
369 --noskip) noskip=true; shift;;
370 --outdir) outdir="$2"; shift; shift;;
371 --compdir) compdir="$2"; shift; shift;;
372 --node) isnode=true; shift;;
373 *) stop=true
374 esac
375 done
376 enginebinname=$engine
377 isinterpret=
378 case $engine in
379 nitg)
380 engine=nitg-s;
381 enginebinname=nitg;
382 OPT="--separate $OPT --compile-dir $compdir"
383 savdirs="sav/nitg-common/"
384 ;;
385 nitg-s)
386 enginebinname=nitg;
387 OPT="--separate $OPT --compile-dir $compdir"
388 savdirs="sav/nitg-common/"
389 ;;
390 nitg-e)
391 enginebinname=nitg;
392 OPT="--erasure $OPT --compile-dir $compdir"
393 savdirs="sav/nitg-common/"
394 ;;
395 nitg-sg)
396 enginebinname=nitg;
397 OPT="--semi-global $OPT --compile-dir $compdir"
398 savdirs="sav/nitg-common/"
399 ;;
400 nitg-g)
401 enginebinname=nitg;
402 OPT="--global $OPT --compile-dir $compdir"
403 savdirs="sav/nitg-common/"
404 ;;
405 nit)
406 engine=niti
407 isinterpret=true
408 ;;
409 niti)
410 enginebinname=nit
411 isinterpret=true
412 ;;
413 nitvm)
414 isinterpret=true
415 savdirs="sav/niti/"
416 ;;
417 emscripten)
418 enginebinname=nitg
419 OPT="-m emscripten_nodejs.nit --semi-global $OPT --compile-dir $compdir"
420 savdirs="sav/nitg-sg/"
421 ;;
422 nitc)
423 echo "disabled engine $engine"
424 exit 0
425 ;;
426 *)
427 echo "unknown engine $engine"
428 exit 1
429 ;;
430 esac
431
432 savdirs="sav/$engine $savdirs sav/"
433
434 # The default nitc compiler
435 [ -z "$NITC" ] && find_nitc
436
437 # Set NIT_DIR if needed
438 [ -z "$NIT_DIR" ] && export NIT_DIR=..
439
440 # Mark to distinguish files among tests
441 # MARK=
442
443 if [ $# = 0 ]; then
444 usage;
445 exit
446 fi
447
448 # CLEAN the out directory
449 rm -rf "$outdir/" 2>/dev/null
450 mkdir "$outdir" 2>/dev/null
451
452 # File where error tests are outputed
453 # Old ERRLIST is backuped
454 ERRLIST=${ERRLIST:-errlist}
455 ERRLIST_TARGET=$ERRLIST
456
457 # Initiate new ERRLIST
458 if [ "x$ERRLIST" = "x" ]; then
459 ERRLIST=/dev/null
460 else
461 ERRLIST=$ERRLIST.tmp
462 > "$ERRLIST"
463 fi
464
465 ok=""
466 nok=""
467 todos=""
468
469 if [ "x$XMLDIR" = "x" ]; then
470 xml="tests-$engine.xml"
471 else
472 sum=`echo $@ | md5sum | cut -f1 -d " "`
473 xml="$XMLDIR/tests-$engine-$sum.xml"
474 mkdir -p "$XMLDIR"
475 fi
476
477 echo >$xml "<testsuites><testsuite>"
478
479 for ii in "$@"; do
480 if [ ! -f "$ii" ]; then
481 echo "File '$ii' does not exist."
482 continue
483 fi
484 f=`basename -- "$ii" .nit`
485
486 pack="tests.${engine}".`echo $ii | perl -p -e 's|^../([^/]*)/([a-zA-Z_]*).*|\1.\2| || s|^([a-zA-Z]*)[^_]*_([a-zA-Z]*).*|\1.\2| || s|\W*([a-zA-Z_]*).*|\1|'`
487
488 # Sould we skip the file for this engine?
489 need_skip "$f" "$f" "$pack" && continue
490
491 tmp=${ii/../AA}
492 if [ "x$tmp" = "x$ii" ]; then
493 includes="-I . -I ../lib/standard -I ../lib/standard/collection -I alt"
494 else
495 includes="-I alt"
496 fi
497
498 for i in "$ii" `./alterner.pl --start '#' --altsep '_' -- "$ii"`; do
499 bf=`basename -- "$i" .nit`
500 ff="$outdir/$bf"
501
502 # Sould we skip the alternative for this engine?
503 need_skip "$bf" "$bf" "$pack" && continue
504
505 echo -n "=> $bf: "
506
507 if [ -f "$f.inputs" ]; then
508 inputs="$f.inputs"
509 export MNIT_READ_INPUT="$f.inputs"
510 else
511 inputs=/dev/null
512 export MNIT_READ_INPUT=/dev/null
513 fi
514
515 ffout="$ff.bin"
516 if [ "$engine" = "emscripten" ]; then
517 ffout="$ff.bin.js"
518 fi
519
520 if [ -n "$isinterpret" ]; then
521 cat > "$ff.bin" <<END
522 exec $NITC --no-color $OPT $includes -- $(printf '%q' "$i") "\$@"
523 END
524 chmod +x "$ff.bin"
525 > "$ff.cmp.err"
526 > "$ff.compile.log"
527 ERR=0
528 echo 0.0 > "$ff.time.out"
529 else
530 if skip_cc "$bf"; then
531 nocc="--no-cc"
532 else
533 nocc=
534 fi
535 # Compile
536 if [ "x$verbose" = "xtrue" ]; then
537 echo ""
538 echo $NITC --no-color $OPT -o "$ffout" "$includes" $nocc "$i"
539 fi
540 NIT_NO_STACK=1 JNI_LIB_PATH=$JNI_LIB_PATH JAVA_HOME=$JAVA_HOME \
541 saferun -o "$ff.time.out" $NITC --no-color $OPT -o "$ffout" $includes $nocc "$i" 2> "$ff.cmp.err" > "$ff.compile.log"
542 ERR=$?
543 if [ "x$verbose" = "xtrue" ]; then
544 cat -- "$ff.compile.log"
545 cat >&2 -- "$ff.cmp.err"
546 fi
547 fi
548 if [ "$engine" = "emscripten" ]; then
549 echo > "$ff.bin" "nodejs $ffout \"\$@\""
550 chmod +x "$ff.bin"
551 if grep "Fatal Error: more than one primitive class" "$ff.compile.log" > /dev/null; then
552 echo " [skip] do no not imports kernel"
553 echo >>$xml "<testcase classname='`xmlesc "$pack"`' name='`xmlesc "$bf"`' `timestamp`><skipped/></testcase>"
554 continue
555 fi
556 fi
557 if [ "$ERR" != 0 ]; then
558 echo -n "! "
559 cat -- "$ff.compile.log" "$ff.cmp.err" > "$ff.res"
560 process_result "$bf" "$bf" "$pack"
561 elif [ -n "$nocc" ]; then
562 # not compiled
563 echo -n "nocc "
564 > "$ff.res"
565 process_result "$bf" "$bf" "$pack"
566 elif [ -x "$ff.bin" ]; then
567 if skip_exec "$bf"; then
568 # No exec
569 > "$ff.res"
570 process_result "$bf" "$bf" "$pack"
571 break
572 fi
573 echo -n ". "
574 # Execute
575 args=""
576 if [ "x$verbose" = "xtrue" ]; then
577 echo ""
578 echo "NIT_NO_STACK=1 $ff.bin" $args
579 fi
580 NIT_NO_STACK=1 LD_LIBRARY_PATH=$JNI_LIB_PATH \
581 saferun -a -o "$ff.time.out" "$ff.bin" $args < "$inputs" > "$ff.res" 2>"$ff.err"
582 mv "$ff.time.out" "$ff.times.out"
583 awk '{ SUM += $1} END { print SUM }' "$ff.times.out" > "$ff.time.out"
584
585 if [ "x$verbose" = "xtrue" ]; then
586 cat -- "$ff.res"
587 cat >&2 -- "$ff.err"
588 fi
589 if [ -f "$ff.write" ]; then
590 cat -- "$ff.write" >> "$ff.res"
591 elif [ -d "$ff.write" ]; then
592 LANG=C /bin/ls -F "$ff.write" >> "$ff.res"
593 fi
594 cp -- "$ff.res" "$ff.res2"
595 cat -- "$ff.cmp.err" "$ff.err" "$ff.res2" > "$ff.res"
596 process_result "$bf" "$bf" "$pack"
597
598 if [ -f "$f.args" ]; then
599 fargs=$f.args
600 cptr=0
601 while read line; do
602 ((cptr=cptr+1))
603 args="$line"
604 bff=$bf"_args"$cptr
605 fff=$ff"_args"$cptr
606 name="$bf args $cptr"
607
608 # Sould we skip the input for this engine?
609 need_skip "$bff" " $name" "$pack" && continue
610
611 # use a specific inputs file, if required
612 if [ -f "$bff.inputs" ]; then
613 ffinputs="$bff.inputs"
614 else
615 ffinputs="$inputs"
616 fi
617
618 rm -rf "$fff.res" "$fff.err" "$fff.write" 2> /dev/null
619 if [ "x$verbose" = "xtrue" ]; then
620 echo ""
621 echo "NIT_NO_STACK=1 $ff.bin" $args
622 fi
623 echo -n "==> $name "
624 echo "$ff.bin $args" > "$fff.bin"
625 chmod +x "$fff.bin"
626 WRITE="$fff.write" saferun -o "$fff.time.out" sh -c "NIT_NO_STACK=1 $fff.bin < $ffinputs > $fff.res 2>$fff.err"
627 if [ "x$verbose" = "xtrue" ]; then
628 cat -- "$fff.res"
629 cat >&2 -- "$fff.err"
630 fi
631 if [ -f "$fff.write" ]; then
632 cat -- "$fff.write" >> "$fff.res"
633 elif [ -d "$fff.write" ]; then
634 LANG=C /bin/ls -F -- "$fff.write" >> "$fff.res"
635 fi
636 if [ -s "$fff.err" ]; then
637 cp -- "$fff.res" "$fff.res2"
638 cat -- "$fff.err" "$fff.res2" > "$fff.res"
639 fi
640 process_result "$bff" " $name" "$pack"
641 done < "$fargs"
642 fi
643 elif [ -f "$ff.bin" ]; then
644 #Not executable (platform?)"
645 > "$ff.res"
646 process_result "$bf" "$bf" "$pack"
647 else
648 echo -n "! "
649 cat -- "$ff.cmp.err" > "$ff.res"
650 echo "Compilation error" > "$ff.res"
651 process_result "$bf" "$bf" "$pack"
652 fi
653 done
654 done
655
656 if [ "x$isnode" = "xfalse" ]; then
657 echo "engine: $engine ($enginebinname $OPT)"
658 echo "ok: " `echo $ok | wc -w` "/" `echo $ok $nok $nos $todos | wc -w`
659
660 if [ -n "$nok" ]; then
661 echo "fail: $nok"
662 echo "There were $(echo $nok | wc -w) errors ! (see file $ERRLIST)"
663 fi
664 if [ -n "$nos" ]; then
665 echo "no sav: $nos"
666 fi
667 if [ -n "$todos" ]; then
668 echo "todo/fixme: $todos"
669 fi
670 if [ -n "$remains" ]; then
671 echo "sav that remains: $remains"
672 fi
673 fi
674
675 # write $ERRLIST
676 if [ "x$ERRLIST" != "x" ]; then
677 if [ -f "$ERRLIST_TARGET" ]; then
678 mv "$ERRLIST_TARGET" "${ERRLIST_TARGET}.bak"
679 fi
680 uniq $ERRLIST > $ERRLIST_TARGET
681 rm $ERRLIST
682 fi
683
684 echo >>$xml "</testsuite></testsuites>"
685
686 if [ -n "$nok" ]; then
687 exit 1
688 else
689 exit 0
690 fi